<template>
  <div
    @click="toggleSelect"
    class="max-w-[320px] m-auto text-center"
    ref="selectRef"
  >
    <div :class="isSelectOpen ? 'border-select-is-open' : 'border-select-border'" class="relative border-2 rounded-[8px] max-w-[300px]">
      <div class="flex justify-center items-center cursor-pointer py-[10px] px-[16px]">
          <h2 class="text-selected-option font-selected-option pr-[20px]">{{selectedOption}}</h2>
        <span v-if="isSelectOpen" class="ml-auto"><img class="w-[18px]" alt="ᐃ" src="../assets/select-icons/select-icon-close.svg" /></span>
        <span class="ml-auto" v-else><img alt="▼" class="w-[18px]" src="../assets/select-icons/select-icon-open.svg" /></span>
      </div>
    </div>
    <div v-show="isSelectOpen" class="absolute w-full z-10 bg-white max-w-[300px] text-center border-[2px] border-select-border shadow-select-shadow mt-[10px]" @click.stop>
        <div v-if="filterable" class="flex relative max-w-[280px] m-auto items-center mt-[5px]">
          <input v-model="filterValue" placeholder="Поиск опций" class="border-[1px] rounded-[8px] mt-[5px] border-grey w-full pt-[5px] pb-[5px] pl-[10px] focus:outline-none focus:border-1" type="text"><span @click="cleanFilter" class="absolute right-0 pr-[10px] pt-[2px] cursor-pointer select-none">X</span>
        </div>
        <slot name="options" :options="options" :filteredOption="filteredOption" :isOptionSelected="isOptionSelected" :getOptionValue="getOptionValue" :selectOption="selectOption" :getOptionLabel="getOptionLabel">
          <div
            v-for="option in filteredOption"
            :class="{'font-bold': isOptionSelected(option)}"
            :key="getOptionValue(option)"
            @click="selectOption(option)"
            class="cursor-pointer text-left ml-[20px] mt-[15px] mb-[15px]"
          >
          <div v-if="multiple" class="flex items-center">
            <span class="w-[20px] h-[20px] border-[1px] mr-2 rounded-[4px]"><img class="w-[30px] h-[18px] bg-[#A16CF6] rounded-[4px]" v-show="isOptionSelected(option)" src="../assets/checkbox-icons/active-checkbox.svg" alt="X"></span>
            <h3>{{getOptionLabel(option)}}</h3>
          </div>
          <h3 v-else>{{getOptionLabel(option)}}</h3>
          </div>
        </slot>
        <h3 v-show="!filteredOption.length" class="text-gray-400 select-none pb-[5px]">Таких опций нет</h3>
    </div>
  </div>
</template>

<script setup>
import { onUnmounted, onMounted, ref, defineEmits, computed } from 'vue'
const props = defineProps({
  getOptionLabel: {
    type: Function,
    default: (option) => option?.title
  },
  getOptionValue: {
    type: Function,
    default: (option) => option?.uniqueIdentifier
  },
  modelValue: {
    type: [Array, Object],
    required: true
  },
  getSearchString: {
    type: Function,
    default: null
  },
  filterable: { type: Boolean, default: false },
  multiple: { type: Boolean, default: false },
  placeholder: {
    type: String,
    default: 'Выберите опцию'
  },
  options: {
    type: Array,
    default: () => []
  }
})

const filterValue = ref('')
const isSelectOpen = ref(false)

// Catch click outside
const selectRef = ref(null)
const closeSelectOutside = (e) => {
  if (!selectRef.value.contains(e.target)) {
    isSelectOpen.value = false
  }
}

const cleanFilter = () => {
  filterValue.value = ''
}

const toggleSelect = () => {
  isSelectOpen.value = !isSelectOpen.value
  filterValue.value = ''
}

const selectedOption = computed(() => {
  if (props.multiple) {
    return (
      props.modelValue.map((option) => props.getOptionLabel(option)).join(', ') || props.placeholder
    )
  } else {
    return props.getOptionLabel(props.modelValue) || props.placeholder
  }
})

onMounted(() => {
  document.addEventListener('click', closeSelectOutside)
})
onUnmounted(() => {
  document.removeEventListener('click', closeSelectOutside)
})

const isOptionSelected = (option) => {
  if (props.multiple) {
    return props.modelValue.find((opt) => props.getOptionValue(opt) === props.getOptionValue(option))
  } else {
    return (
      props.getOptionValue(props.modelValue) === props.getOptionValue(option)
    )
  }
}

const emit = defineEmits({ 'update:model-value': null })

const selectOption = (option) => {
  if (props.multiple) {
    if (isOptionSelected(option)) {
      emit('update:model-value', props.modelValue.filter((opt) => props.getOptionValue(opt) !== props.getOptionValue(option)))
    } else {
      emit('update:model-value', [...props.modelValue, option])
    }
  } else {
    emit('update:model-value', option)
    isSelectOpen.value = false
  }
}

const filteredOption = computed(() => {
  const getSearchString = props.getSearchString || props.getOptionLabel
  return filterValue.value ? props.options.filter(option => getSearchString(option).toLowerCase().includes(filterValue.value.toLowerCase())) : props.options
})
</script>
